/**************************************************************
 * MAT 259 - Winter 2022                                       *
 * Data Visualization for MoMA Dataset - Project3              *
 *                                                             *
 * Author: Jiaxin Wu                                           *
 * Supervisor: George Legrady                                  *
 *                                                             *
 ***************************************************************/

import controlP5.*;
import peasy.*;
ControlP5 cp5;
PeasyCam cam;

Table table;
int numRows;
int offset = -500;
boolean showPoint;
boolean showLine;
boolean showBooks;
boolean showPhotography;
boolean showArchitecture;
boolean showDrawings;
boolean showPainting;
boolean showFilm;
boolean showMedia;
boolean showFluxus;

ArrayList<Art> arts = new ArrayList<Art>();

void setup(){
  //size(800, 600, P3D);
  size(1920, 1080, P3D);
  pixelDensity(displayDensity());
  //background(0);
  
  cp5 = new ControlP5(this);
  cam = new PeasyCam(this, 200); 
  
  //table = loadTable("data.csv", "header");
  //table = loadTable("data_2D.csv", "header");
  table = loadTable("data_3D.csv", "header");
  table = loadTable("data_3D_sample.csv", "header");
  numRows = table.getRowCount();
  //numRows = 1000;
  
  for (int i=0; i<numRows;i++){
    //int ArtworkID;
    String Title = table.getString(i, 1);
    //int ArtistID;
    String Name = table.getString(i, 3);
    float Date = table.getFloat(i, 4);
    //float Date0 = table.getFloat(i, 4);
    float AcquisitionDate = table.getFloat(i, 5);
    String Department = table.getString(i, 6);
    //String Nationality;
    //String Gender;
    // artist
    float x1 = table.getFloat(i, 9);
    float y1 = table.getFloat(i, 10);
    float z1= table.getFloat(i, 11);
    // artwork
    float x0 = table.getFloat(i, 12);
    float y0 = table.getFloat(i, 13);
    float z0 = table.getFloat(i, 14);
    // from artist to artwork
    float x = table.getFloat(i, 12);
    float y = table.getFloat(i, 13);
    float z= table.getFloat(i, 14);
    float x_diff = table.getFloat(i, 15);
    float y_diff = table.getFloat(i, 16);
    float z_diff = table.getFloat(i, 17);
    
    Art newArt = new Art(Title, Name, Date, AcquisitionDate, Department, 
    x, y, z, x0, y0, z0, x1, y1, z1, x_diff, y_diff, z_diff);
    arts.add(newArt);
  }
  print(arts.size());
  
  showPoint = true;
  showLine = true;
  showBooks = true;
  showPhotography = true;
  showArchitecture = true;
  showDrawings = true;
  showPainting = true;
  showFilm = true;
  showMedia = true;
  showFluxus = true;
  int X=10;
  cp5.addToggle("showPoint").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showLine").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showBooks").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showPhotography").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showArchitecture").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showDrawings").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showPainting").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showFilm").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showMedia").setPosition(X,10).setColorLabel(0);
  X+=80;
  cp5.addToggle("showFluxus").setPosition(X,10).setColorLabel(0);

  cp5.setAutoDraw(false);
}

void draw(){
  background(255,255,255,20);
  
  ////stroke(#FF0000);
  //stroke(#E57373);
  //circle(0, 0, 400);
  //rotateX(PI/2);
  //circle(0, 0, 400);
  //rotateY(PI/2);
  //circle(0, 0, 400);
  
  for (int i=0;i<arts.size();i++){
    Art theArt = arts.get(i);
    float x, y, z;
    float x0, y0, z0;
    float x1, y1, z1;
    float x_diff, y_diff, z_diff;
    color c;
    
    x = theArt.x * 10;
    y = theArt.y * 10;
    z = theArt.z * 10;
    x0 = theArt.x0 * 10;
    y0 = theArt.y0 * 10;
    z0 = theArt.z0 * 10;
    x1 = theArt.x1 * 10;
    y1 = theArt.y1 * 10;
    z1 = theArt.z1 * 10;
    x_diff = theArt.x_diff * 10;
    y_diff = theArt.y_diff * 10;
    z_diff = theArt.z_diff * 10;
    //z0 = theArt.Date0 - 2000;
    //z1 = theArt.Date - 2000;
    //z2 = theArt.AcquisitionDate - 2000;
    
    //float xstep = (theArt.x0-theArtx)/theArt

    if (showBooks==true & theArt.Department.equals("Prints & Illustrated Books")){
    }
    else if (showPhotography==true & theArt.Department.equals("Photography")){
    }
    else if (showArchitecture==true & theArt.Department.equals("Architecture & Design")){
    }
    else if (showDrawings==true & theArt.Department.equals("Drawings")){
    }
    else if (showPainting==true & theArt.Department.equals("Painting & Sculpture")){
    }
    else if (showFilm==true & theArt.Department.equals("Film")){
    }
    else if (showMedia==true & theArt.Department.equals("Media and Performance Art")){
    }
    else if (showFluxus==true & theArt.Department.equals("Fluxus Collection")){
    }
    else{
      continue;
    }
    if (showLine == true){
      noFill();
      stroke(#000000);
      strokeWeight(0.2);
      line(x0, y0, z0, x, y, z);
      //curve( 
      //      x0/3+x*2/3, y0/3+y*2/3+20, z0/3+z1*2/3, 
      //      x0, y0, z0, 
      //      x, y, z1,
      //      x0*2/3+x/3+20, y0*2/3+y/3, z0*2/3+z1/3);  
    }
   
    if (showPoint==true){
      // artwork
      //noStroke();
      //lights();
      pushMatrix();
      translate(x, y, z);
      c = colorDetermine(theArt.Department);
      stroke(c);
      //stroke(#000000);
      strokeWeight(7);
      point(0, 0, 0);
      //sphere(1);
      popMatrix();
      
      // artist
      pushMatrix();
      translate(x0, y0, z0);
      stroke(#000000);
      //stroke(#FF0000);
      strokeWeight(3);
      point(0, 0, 0);
      //sphere(1);
      popMatrix();
    }

    //if (theArt.Date<theArt.AcquisitionDate){
    if (abs(theArt.x-theArt.x1)>0.001){
      //theArt.Date += 0.1;
      theArt.x += x_diff/50000;
      theArt.y += y_diff/50000;
      theArt.z += z_diff/50000;
      
      //theArt.x += (float)Math.cos((theArt.Date-offset)/20)*(theArt.Date-offset)/10000;
      //theArt.y += (float)Math.sin((theArt.Date-offset)/20)*(theArt.Date-offset)/10000;
    }
    
    float p_x = screenX(x,y,z);
    float p_y = screenY(x,y,z);
    // calculate the distance between (p_x, p_y), (mouse_X, mouse_Y)
    float distanceObjectMouse = sq(p_x - mouseX) + sq(p_y - mouseY);
    if (distanceObjectMouse < 10){
      fill(#FF0000);
      stroke(#FF0000);
      strokeWeight(2);
      textSize(50);
      pushMatrix();
      scale(0.1);
      float[] rotations = cam.getRotations();
      rotateX(rotations[0]);
      rotateY(rotations[1]);
      rotateZ(rotations[2]);
      //text(theArt.Title,0,0,0);
      text(theArt.Title,x,y,z);
      textAlign(LEFT,CENTER);
      popMatrix();
    }
  }
  gui();
}


void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void keyPressed() {
if(key == 's'){
    saveFrame("screenshot"+frameCount+".png");
  }
}
